//********************************************************************
//*** ResourcePool/SQL/NULL.t.cc
//*** Copyright (c) 2003-2007 by Markus Winand <mws@fatalmind.com>
//*** $Id: NULL.t.cc,v 1.11 2007/09/06 18:16:48 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

void test_NULL_init(RP& p)
{
	drop(p);
	init(p);
}

void test_NULL_insert(RP& p)
{
	RP::Command::SQLExecute ins(p, "insert into hirsch (id, ukn) values (1000, null)");
	p.execute(ins);
	RP::Command::SQLExecute ins2(p, "insert into hirsch (id, ukn) values (?, ?)");
	std::string nul("notnull");
	ins2.bind(0, 1001);
	ins2.bind(1, nul, true);
	p.execute(ins2);
	ins2.bind(0, 1002);
	ins2.bind(1, nul);
	p.execute(ins2);
}

void test_NULL_select(RP& p)
{
	string sql("select id, ukn from hirsch where id = ?");
	RP::Command::SQLSelectRow cmd(p, sql);
	int col1;
	std::string col2;

	cmd.bindout(0, col1);
	cmd.bindout(1, col2);
	cmd.bind(0, 1000);
	p.execute(cmd);
	assertTrue(cmd.isnull(1));
	assertEqualT(int, col1, 1000);

	cmd.bind(0, 1001);
	p.execute(cmd);
	assertTrue(cmd.isnull(1));
	assertEqualT(int, col1, 1001);

	cmd.bind(0, 1002);
	p.execute(cmd);
	assertEqualT(int, col1, 1002);
	assertFalse(cmd.isnull(1));
}

void test_NULL_cleanup(RP& p) {
	drop(p);
}
