#include "t/main.hh"

#include "TaskRunnerPool.hh"

#include <iostream>

using namespace fatalmind;
using namespace std;

class myTestTask: public Task {
	public:
		myTestTask()
		: exec(0)
		{
		}

		virtual void run() {
			++exec;
		}
		int exec;
};


void TEST_TaskRunnerPool_one() {
	TaskRunnerPool pool;
	gc_ptr<myTestTask, MultiThreadedModel<> > t(new myTestTask());
	
	assertEqual(t->exec, 0);
	TaskRunner::ID id = pool.run(t);
	id.wait();
	assertEqual(t->exec, 1);
	id = pool.run(t);
	id.wait();
	assertEqual(t->exec, 2);
	id = pool.run(t);
	id.wait();
	assertEqual(t->exec, 3);
	id = pool.run(t);
	id.wait();
	assertEqual(t->exec, 4);
	id = pool.run(t);
	id.wait();
	assertEqual(t->exec, 5);
	id = pool.run(t);
	id.wait();
	assertEqual(t->exec, 6);
	id = pool.run(t);
	id.wait();
	assertEqual(t->exec, 7);
	id = pool.run(t);
	id.wait();
	assertEqual(t->exec, 8);
	id = pool.run(t);
	id.wait();
	assertEqual(t->exec, 9);
	id = pool.run(t);
	id.wait();
	assertEqual(t->exec, 10);
	id = pool.run(t);
	id.wait();
	assertEqual(t->exec, 11);
	id = pool.run(t);
	id.wait();
	assertEqual(t->exec, 12);
	id = pool.run(t);
	id.wait();
	assertEqual(t->exec, 13);
	id = pool.run(t);
	id.wait();
	assertEqual(t->exec, 14);
}

void TEST_PERF_TaskRunnerPool()
{
	TaskRunnerPool pool;
	gc_ptr<myTestTask, MultiThreadedModel<> > t(new myTestTask());
	for (int i = 0; i <1000; ++i) {
		pool.run(t);
	}	
}

void TEST_PERF_TaskRunnerPool_detached()
{
	TaskRunnerPool pool;
	gc_ptr<myTestTask, MultiThreadedModel<> > t(new myTestTask());
	for (int i = 0; i <1000; ++i) {
		pool.runDetached(t);
	}	
}
