//********************************************************************
//*** ResourcePool/oracle/ResourcePoolInstances.cc
//*** Copyright (c) 2003-2007 by Markus Winand <mws@fatalmind.com>
//*** $Id: ResourcePoolInstances.cc,v 1.21 2007/09/19 12:42:38 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of 
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#ifndef RESOURCEPOOL_RESOURCEPOOL_HH
#include "ResourcePool/ResourcePool.hh"
#endif

#include "ResourcePool/ResourcePool.cc"
#include "ResourcePool/Execute.cc"
#include "ResourcePool/Command.cc"
#include "ResourcePool/BatchCommand.cc"

#ifndef RESOURCEPOOL_ORACLE_RESOURCEPOOL_HH
#include "ResourcePool/oracle/ResourcePool.hh"
#endif

#ifndef RESOURCEPOOL_ORACLE_RESOURCE_HH
#include "ResourcePool/oracle/Resource.hh"
#endif

#ifndef CACHE_CACHE_HH
#include "cache/Cache.hh"
#endif

#include "cache/Cache.cc"

#include "Resource.cc"
#include "Factory.cc"

#include "SelectListMetaDataCache.hh"
#include "CommandInterface.hh"

namespace fatalmind {

template class Command<oracle::ResourceType<DefaultThreadedModel, oracle::SelectListMetaDataCache > >;
template class Command<oracle::ResourceType<DefaultThreadedModel, oracle::SelectListMetaDataNopCache > >;

template class ResourcePool<ResourceType::oracle>;
template class oracleResource<DefaultThreadedModel >;
template class oracleFactory<DefaultThreadedModel, oracle::SelectListMetaDataCache>;
//template class BatchCommand<oracle::CommandInterface<DefaultThreadedModel, oracle::SelectListMetaDataCache> >;
//template class BatchCommand<oracle::CommandInterface<DefaultThreadedModel, oracle::SelectListMetaDataNopCache> >;


//template oracle::SelectListMetaDataCache<DefaultThreadedModel>::type;
template class Cache<std::string
        , oracle::SelectListMetaData
        , oracle::SelectListMetaDataCtor
        , LeastRecentlyUsedExpirationPolicy
        , DefaultThreadedModel>;

//template class oracle::SQLBatch<DefaultThreadedModel, oracle::SelectListMetaDataCache >;
//template class oracle::SQLBatch<DefaultThreadedModel, oracle::SelectListMetaDataNopCache >;
template class BatchCommand<Command<oracle::ResourceType<DefaultThreadedModel, oracle::SelectListMetaDataCache > > >;
template class BatchCommand<Command<oracle::ResourceType<DefaultThreadedModel, oracle::SelectListMetaDataNopCache > > >;

} //namespace fatalmind

