//********************************************************************
//*** ResourcePool/oracle/SQLSelect.hh
//*** Copyright (c) 2003-2007 by Markus Winand <mws@fatalmind.com>
//*** $Id: SQLSelect.hh,v 1.21 2007/09/19 12:42:38 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of 
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#ifndef RESOURCEPOOL_ORACLE_SQLSELECT_HH
#define RESOURCEPOOL_ORACLE_SQLSELECT_HH

#ifndef RESOURCEPOOL_ORACLE_SQLSELECTROW_HH
#include "SQLSelectRow.hh"
#endif

#ifndef RESOURCEPOOL_SQL_SQLSELECT_HH
#include "ResourcePool/SQL/SQLSelect.hh"
#endif

namespace fatalmind {
namespace oracle {

/**
 * Issue an select statement which returns an arbitary number of rows.
 */
template<class TM, template<class> class SLMDC>
class SQLSelect
: public SQLSelectRow<TM, SLMDC>
, public fatalmind::SQLSelect
{
		typedef SQLSelectRow<TM, SLMDC> super;
	protected:
		using super::_SQL;
		using super::_sth;
	public:
		SQLSelect(const std::string& SQL);
		SQLSelect(const ResourcePool<ResourceType<TM> >& p, const std::string& SQL);
		SQLSelect(const SQLSelect&);
		virtual ~SQLSelect();

		using super::execute;
	protected:
		void _execute(oracleResource<TM>&, StatementCache&);
};

} // namespace oracle
} // namespace fatalmind
#endif
